#!/usr/bin/env ruby

#  Copyright (C) 2006-2012 by Nevil Brownlee,
#  CAIDA | University of Auckland

# ./fix-cpr-date.rb '*.c' 2004 2006
#   Leave out dates to search for Copyright

dir = ARGV[0];  old = ARGV[1];  new = ARGV[2]
test = old.nil? || new.nil?

if ARGV.length == 1
  puts "Search #{dir}, look for 'Copyright' (make no changes)"
elsif ARGV.length == 2
  puts "Search #{dir}, look for #{old} (make no changes)"
elsif ARGV.length == 3
  puts "Search #{dir}, change #{old} to #{new}"
else
  puts "Wrong number of arguments..\n   fix-c-date.rb '*.c' 2004 2006"
  exit
end

Dir[dir].sort.each do |fn|
  puts "fn=#{fn}"
  if File.stat(fn).directory?
    print "  directory\n"
    next
  end

  change_reqd = false  # Pass 1, does it need changing?
  File.open(fn, 'rb') do |file|
    file.each_line do |line|
      if line =~ /Copyright.*Nevil/ || line =~ /display.*Copyright/
        puts line
        change_reqd = true
        end      
    end
  end

  next if test || !change_reqd
  print "==> Updating #{fn}\n"

  mode = File.stat(fn).executable? ? File.stat(fn).mode : 0
  outfn = "#{fn}.new"
  out = File.open(outfn, "w")

  oldp = "-#{old}"
  newr = "-#{new}"
  File.open(fn, 'rb') do |file|
    file.each_line do |line|
      if line =~ /Copyright.*Nevil/ || line =~ /display.*Copyright/
        if !line.index(oldp).nil?      
          line.sub!(oldp, newr)
        else
          line.sub!(old, "#{old}-#{new}")
        end
      end
      out.puts line
    end
  end
  out.close
  File.rename(fn, "#{fn}\~")
  File.rename(outfn, fn)
  File.chmod(mode, fn) if mode != 0
end
