#!/usr/local/bin/ruby

# 0938, Thu 16 Jun 11 (NZST)
#
# mon-find-unan.rb: Find Monitor's sum2 files with unanalysed sources
#   ./mon-find-unan.rb  2011-01-03 2011-05-31
#
# Copyright 2009-2012, Nevil Brownlee, CAIDA | U Auckland

require "#{File.dirname($0)}/owt-config"
require "#{Home}/owt-rb/owt-support"  # owtmon utilities and constants          
StatsDir = SummaryDir

def print_error(msg)
  $stderr.print ">>> #{msg}\n"
  $stderr.print "    #{$0}  monitor  first-ymd last_ymd  reqd_hour\n"
  exit
end

start_date = ARGV[0]
if start_date =~ /^(20\d\d)-(\d\d)-(\d\d)$/
   sd = $1 + $2 + $3
else 
  print_error("first_date not yyyy-mm-dd !!")
end
last_date = ARGV[1]
if last_date =~ /^(20\d\d)-(\d\d)-(\d\d)$/
   ed = $1 + $2 + $3
else 
  print_error("last_date not yyyy-mm-dd !!")
end
date_range = "#{sd}-#{ed}"

sds = SummaryDataSet.new(StatsDir, start_date,last_date, false)

last_ts = last_format_ver = nil
sds.each do |sf|  # Get files within range of days
  err = nil
  #print "#{sf.ymdh} ...\n"
  if sf.format_ver != last_format_ver
    if !last_format_ver.nil?
      print "#{sf.ymdh}\n" if !err;  err = true
      print "  Format change, to #{last_format_ver}\n"
    end
    last_format_ver = sf.format_ver
  end

  sl = sf.find_section('source_counts')
  if !sl.nil?
    sla = sl.split(' ')
    if sla[0] != '0'
      print "#{sf.ymdh}: #{sl.chomp}\n"
    end
  end

end
