#!/usr/local/bin/ruby

# 1105, Wed 20 Dec 11 (NZDT)
#
# update-home.rb: updates base-directory name in iatmon support files
#
# Copyright 2009-2012, Nevil Brownlee, CAIDA | U Auckland

cronenv_fn = 'iatmon-cron-env.sh'
crontab_fn = 'iatmon-crontab.txt'
owtconf_fn = 'owt-config.rb'

$iatmon_dir = Dir.pwd 
print "   iatmon directory = #{$iatmon_dir}\n" 
 
def update_cron_file(fn)
  of = File.open(fn, 'r');  nf = File.open("#{fn}.new", 'w')
  of.each do |line|
    if line !~ /iatmon-/
      nf.print line
    else
      # print ">>> #{line}"

      newline = ''
      while line =~ /\/(\S+\/)(iatmon-[.0123456789]+)/
        home_dir = '/' + $1;  iat_dir = $2
        len = home_dir.size + iat_dir.size
        x = line.index(/\/(\S+\/)(iatmon-[.0123456789]+)/)
        newline += line[0,x] + $iatmon_dir
        line[0,x+len] = ''
      end
      newline += line
      # print "=== #{newline}\n"
      nf.print newline
    end
  end
  of.close;  nf.close

  File.rename(fn, "#{fn}.bak")
  File.rename("#{fn}.new", fn)
end

update_cron_file(cronenv_fn)
File.chmod(0744, cronenv_fn)

update_cron_file(crontab_fn)

if File.exists?(owtconf_fn)
  update_cron_file(owtconf_fn)
end


#require "#{File.dirname($0)}/owt-config"
#print "Home = >#{Home}<\n"  # From owt-config.rb
